﻿using System.Windows.Media;
using Clio.Common;
using ff14bot;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using System;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.Objects;

namespace Follower
{
    public class Follower : IBotPlugin
    {
        public bool Equals(IBotPlugin other)
        {
            throw new NotImplementedException();
        }

        public void OnButtonPress()
        {
            if (Core.Me.CurrentTarget != null)
            {
                Leader = Core.Me.CurrentTarget;
                Logging.Write(Colors.SkyBlue, "[Follower] Setting Leader");
            }
        }

        public void OnInitialize()
        {
            throw new NotImplementedException();
        }

        public void OnShutdown()
        {
            throw new NotImplementedException();
        }

        public void OnEnabled()
        {
            throw new NotImplementedException();
        }

        public void OnDisabled()
        {
            throw new NotImplementedException();
        }

        public string Author { get { return "kaihaider"; } }
        public Version Version { get { return new Version(0, 0); } }
        public string Name { get { return "Follower"; } }
        public string Description { get { return "Press Config Button to Follow Target"; } }
        public bool WantButton { get { return true; } }
        public string ButtonText { get { return "Follower"; } }
        public GameObject Leader;
        public bool WeMoving;
        public static bool IsFacingMovement(GameObject face, GameObject location)
        {
            if (face == null || location == null) return false;
            float rotationToLocation = MathEx.NormalizeRadian(MathHelper.CalculateHeading(face.Location, location.Location) + (float)Math.PI);
            float d = Math.Abs(MathEx.NormalizeRadian(face.Heading - rotationToLocation));
            if (d > Math.PI) d = Math.Abs(d - 2 * (float)Math.PI);
            //Logging.Write("Differance: " + d);
            return d < 0.12;
        }
        public static bool IsFacing(GameObject face, GameObject location)
        {
            if (face == null || location == null) return false;
            float rotationToLocation = MathEx.NormalizeRadian(MathHelper.CalculateHeading(face.Location, location.Location) + (float)Math.PI);
            float d = Math.Abs(MathEx.NormalizeRadian(face.Heading - rotationToLocation));
            if (d > Math.PI) d = Math.Abs(d - 2 * (float)Math.PI);
            //Logging.Write("Differance: " + d);
            return d < 0.785f;
        }
        public void OnPulse()
        {
            if (Leader == null || Core.Me.InCombat) return;
            if (!MovementManager.IsMoving && (Leader.Distance(Core.Me.Location) > 24 || !Leader.InLineOfSight()))
            {
                Logging.Write(Colors.SkyBlue, "[Follower] Following Leader");
                Navigator.MoveTo(Leader.Location);
                WeMoving = true;
            }
            if (MovementManager.IsMoving && Leader.Distance(Core.Me.Location) > 24 && !IsFacing(Core.Me,Leader))
            {
                Logging.Write(Colors.SkyBlue, "[Follower] Why you leaving leader?");
                Navigator.MoveTo(Leader.Location);
                WeMoving = true;
            }

            if (MovementManager.IsMoving && Leader.InLineOfSight() && Leader.Distance(Core.Me.Location) < 15)
            {
                Logging.Write(Colors.SkyBlue, "[Follower] We reached our leader!");
                Navigator.PlayerMover.MoveStop();
                WeMoving = false;
            }
        }
    }
}
